<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="试卷主键" prop="examId">
        <el-input
          v-model="queryParams.examId"
          placeholder="请输入试卷主键"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="问题主键" prop="questionId">
        <el-input
          v-model="queryParams.questionId"
          placeholder="请输入问题主键"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="分数" prop="marks">
        <el-input
          v-model="queryParams.marks"
          placeholder="请输入分数"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="排序" prop="sortBy">
        <el-input
          v-model="queryParams.sortBy"
          placeholder="请输入排序"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['manage:busExamInfoQues:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['manage:busExamInfoQues:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['manage:busExamInfoQues:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['manage:busExamInfoQues:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="busExamInfoQuesList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="试卷主键" align="center" prop="examId" />
      <el-table-column label="问题主键" align="center" prop="questionId" />
      <el-table-column label="分数" align="center" prop="marks" />
      <el-table-column label="排序" align="center" prop="sortBy" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['manage:busExamInfoQues:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['manage:busExamInfoQues:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改试卷问题对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="busExamInfoQuesRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="试卷主键" prop="examId">
          <el-input v-model="form.examId" placeholder="请输入试卷主键" />
        </el-form-item>
        <el-form-item label="问题主键" prop="questionId">
          <el-input v-model="form.questionId" placeholder="请输入问题主键" />
        </el-form-item>
        <el-form-item label="分数" prop="marks">
          <el-input v-model="form.marks" placeholder="请输入分数" />
        </el-form-item>
        <el-form-item label="排序" prop="sortBy">
          <el-input v-model="form.sortBy" placeholder="请输入排序" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="BusExamInfoQues">
import { listBusExamInfoQues, getBusExamInfoQues, delBusExamInfoQues, addBusExamInfoQues, updateBusExamInfoQues } from "@/api/manage/busExamInfoQues";

const { proxy } = getCurrentInstance();

const busExamInfoQuesList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    examId: null,
    questionId: null,
    marks: null,
    sortBy: null
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询试卷问题列表 */
function getList() {
  loading.value = true;
  listBusExamInfoQues(queryParams.value).then(response => {
    busExamInfoQuesList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    examId: null,
    questionId: null,
    marks: null,
    sortBy: null
  };
  proxy.resetForm("busExamInfoQuesRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.examId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加试卷问题";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _examId = row.examId || ids.value
  getBusExamInfoQues(_examId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改试卷问题";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["busExamInfoQuesRef"].validate(valid => {
    if (valid) {
      if (form.value.examId != null) {
        updateBusExamInfoQues(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBusExamInfoQues(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _examIds = row.examId || ids.value;
  proxy.$modal.confirm('是否确认删除试卷问题编号为"' + _examIds + '"的数据项？').then(function() {
    return delBusExamInfoQues(_examIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('manage/busExamInfoQues/export', {
    ...queryParams.value
  }, `busExamInfoQues_${new Date().getTime()}.xlsx`)
}

getList();
</script>
